//by Deathfly
//Base on Tartiflette's SCY_laserTorpedoAI and take some refer form MShadowy's WindingMissileAI and Cycerin's SeekerAI. There are too many modifications had been done so it may hardly recognised but you still have my credits.
package data.scripts.AIs.Missiles;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.combat.CollisionClass;
import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.combat.CombatEntityAPI;
import com.fs.starfarer.api.combat.DamageType;
import com.fs.starfarer.api.combat.GuidedMissileAI;
import com.fs.starfarer.api.combat.MissileAIPlugin;
import com.fs.starfarer.api.combat.MissileAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipCommand;
import com.fs.starfarer.api.util.IntervalUtil;
import com.fs.starfarer.api.util.Misc;

import java.awt.Color;
import java.util.Collections;
import java.util.List;

import org.lazywizard.lazylib.CollectionUtils;
import org.lazywizard.lazylib.MathUtils;
import org.lazywizard.lazylib.VectorUtils;
import org.lazywizard.lazylib.combat.AIUtils;
import org.lazywizard.lazylib.combat.CombatUtils;
import org.lazywizard.lazylib.combat.entities.AnchoredEntity;
import org.lazywizard.lazylib.combat.entities.SimpleEntity;

import org.lwjgl.util.vector.Vector2f;

public final class Neutrino_AdvancedTorpedoAI implements MissileAIPlugin, GuidedMissileAI {

    // initialization variable 
    private CombatEngineAPI engine;
    private final MissileAPI missile;
    private CombatEntityAPI target;
    private Vector2f lead = new Vector2f(0f, 0f);
    private final Vector2f zero = new Vector2f(0f, 0f);
    private Vector2f evadingOffset = new Vector2f(0f, 0f);
    private Vector2f leadingOffset = new Vector2f(0f, 0f);
    private boolean firing = false;
    private float firingTimer = 0f;
    private final float flightSpeed;
    private final IntervalUtil OffsetsRCInterval;
    private final float guidefactor;
    private final static float damping = 0.1f;
    private float subLeadingMod = 0f;
    private float omniThrustTimer = 0f;
    private float overshootTimer = overshootLag;
    private float accuracyCompensate = 0f;
    private boolean overshootFlag = false;

    // adjustable DATA
    // MIRV behaviour
    private final float minTimeToSplit = 0.5f; // like the same thing in .proj file
    private final float firingDelay = 0.75f; // time need for missile fully change up after it decide to fire
    private final IntervalUtil flashInterval = new IntervalUtil(0.1F, 0.1F); //for charge up VFX
    private final static Color coler1 = new Color(86, 86, 255, 20);
    private final static Color coler2 = new Color(0, 0, 255, 30);

    // all distances below WILL consider target's radius.
    private float closeRange = 700; // distance to target under this will make missile aim for payload release.
    private float releaseRange = 350; // distance to target under this will make missile fire if it aimed to target
    private final static float releaseRangeHullmodBonus = 60;// 
    private final static int backOffRange = 250; //distance to target under this will make missile try to back off form target and lock the strafe control.

    private final static int payloadSpeed = 500; // use for aim ONLY, will NOT change the payload speed.
    private final static float aimOffset = 35f; // missile will aim to a Random Point On Circumference which radius equal to this instead of the center of target.
    private final static float maxAimOffset = 90f;
    private final static float leadingMod = 0.3f; // 0 means missile will aim to target leading point.

    private final static int payload1 = 1; //payload amount.adjustable
    private final static int payload2 = 3; //payload amount.adjustable
    private final static int payload3 = 10; //payload amount.adjustable

    // Targeting behaviour
    private final static boolean FAF = true; // Fire and Forgot behaviour. set to false will lead a remote control behaviour.(not very good for MIRV)
    private final static float bestLeadRange = 500f; // distance to target under this will lead best target leading calculate. will multiply by MissileGuidance闁挎稑婀旵CM hull mod will make it =2)

    // Maneuver behaviour 
    private final static float overshoot = 60f; //Angle which the target beyond witch the missile will first turn around before accelerating again
    private final static float overshootLag = 1f;
    private boolean omniThrust = false; // if this one is true, missile will always accelerate to target. regardless it's facing.
    private final boolean alwaysAcc = false; // as it's name.
    private final static float omniThrustAccLimit = 0.5f;// Limit omni thrust's acc
    private float omniThrustMaxSpeedLimit = 1f;// Limit omni thrust's MaxSpeed

    //////////////////////
    //  DATA COLLECTING //
    //////////////////////
    public Neutrino_AdvancedTorpedoAI(MissileAPI missile, ShipAPI launchingShip) {
        this.missile = missile;
        flightSpeed = missile.getMaxSpeed();
        guidefactor = 1f + (0.5f * launchingShip.getMutableStats().getMissileGuidance().getModifiedValue());
        omniThrustMaxSpeedLimit = 1 - omniThrustMaxSpeedLimit;
        omniThrustMaxSpeedLimit *= flightSpeed;
        float rangeCompensate = firingDelay * flightSpeed * (launchingShip.getMutableStats().getMissileMaxSpeedBonus().computeEffective(1f) - 1f);
        rangeCompensate += releaseRangeHullmodBonus * launchingShip.getMutableStats().getMissileGuidance().getModifiedValue();
        releaseRange += rangeCompensate;
        closeRange += rangeCompensate;
        accuracyCompensate = (releaseRange - rangeCompensate) / releaseRange;
        // adjustable DATA
        OffsetsRCInterval = new IntervalUtil(2f / guidefactor, 5f / guidefactor); // missile "evading waving" interval
        if (missile.getSource().getVariant().getHullMods().contains("neutrino_sigmaupgrade")) {
            omniThrust = true;
        }
        // adjustable DATA END

        OffsetsRCInterval.forceIntervalElapsed(); //NPE protect
        setTarget(assignCurrentTarget(missile));
    }

    //////////////////////
    //   MAIN AI LOOP   //
    //////////////////////
    @Override
    public void advance(float amount) {

        //once it fired up, it continuity charge up.
        if (firing) {
            releasingPayload(missile, amount);
        }

        if (engine != Global.getCombatEngine()) {
            this.engine = Global.getCombatEngine();
        }

        ////
        //cancelling IF: skip the AI if the game is paused, the missile is engineless or fading
        if (Global.getCombatEngine().isPaused() || missile.isFading() || missile.isFizzling()) {
            return;
        }
        ////

        ////
        //Current Target Check
        if (!FAF) {
            setTarget(assignCurrentTarget(missile));
        } else {
            if (target == null // unset
                    || (target instanceof ShipAPI && !((ShipAPI) target).isAlive()) // dead
                    || (target instanceof ShipAPI && ((ShipAPI) target).isDrone()) // is drone
                    || (missile.getOwner() == target.getOwner()) // friendly
                    || !Global.getCombatEngine().isEntityInPlay(target)) { // completely removed
                setTarget(reAssignTarget(missile));
                overshootFlag = false;
                overshootTimer = overshootLag;
                OffsetsRCInterval.forceIntervalElapsed();// NPE protect
                return;
            }
        }
        ////  
        //Offsets calculate(TEST)
        OffsetsRCInterval.advance(amount);
        float dist = Misc.getDistance(missile.getLocation(), target.getLocation()) - Misc.getTargetingRadius(missile.getLocation(), target, target.getShield() == null ? false : target.getShield().isWithinArc(missile.getLocation()));
//        float dist = MathUtils.getDistance(missile, target);
        if (OffsetsRCInterval.intervalElapsed()) {
            float targetR = target.getCollisionRadius();
            leadingOffset = MathUtils.getRandomPointOnCircumference(zero, Math.min(Math.max(0.9f / guidefactor * (targetR + aimOffset), aimOffset), maxAimOffset / (guidefactor)));
            evadingOffset = MathUtils.getRandomPointInCircle(zero, Math.max(Math.max(targetR * 1.5f, 200f), dist * 0.5f - 200f));
            if (overshootFlag) {
                overshootTimer = 0f;
            }
            subLeadingMod = MathUtils.getRandomNumberInRange(1 - (leadingMod / guidefactor), 1 + (leadingMod / guidefactor));
        }

        ////
        // Target Lead Calculate 
        Vector2f mLoc = missile.getLocation();
        Vector2f tLoc = target.getLocation();
        float mFacing = missile.getFacing();
        //public static Vector2f getBestInterceptPoint(Vector2f point, float speed,Vector2f tLoc, Vector2f targetVel)
        if (dist <= closeRange) {
            lead = AIUtils.getBestInterceptPoint(mLoc, payloadSpeed * subLeadingMod, tLoc, Vector2f.sub(target.getVelocity(), missile.getVelocity(), null));
        } else {
            lead = AIUtils.getBestInterceptPoint(mLoc, flightSpeed * subLeadingMod, tLoc, target.getVelocity());
        }
        //if lead can not be calculated. lead to target directly.
        if (lead == null) {
            lead = Vector2f.add(zero, tLoc, lead);
        }
        // dynamic calculate lead. the closer the better.
        float guideMod = Math.min(1f, guidefactor * bestLeadRange / (dist + 1));
        Vector2f.sub(lead, tLoc, lead);
        lead.scale(guideMod);
        Vector2f.add(lead, tLoc, lead);

        //implant offsets
        if (dist >= closeRange) {
            if (evadingOffset != null) {
                Vector2f.add(lead, evadingOffset, lead);
            }
        } else {
            if (leadingOffset != null) {
                Vector2f.add(lead, leadingOffset, lead);
            }
        }
        // aimAngle = angle deviate from the lead direction
        float aimAngle = MathUtils.getShortestRotation(mFacing, VectorUtils.getAngle(mLoc, lead));
        ////

        ////
        // Universal Missile Attitude Control
        // 
        boolean backOff = false;
        int Thrust = 0, Turn = 0, Strafe = 0;
        if (dist < backOffRange) {
            backOff = true;
        }
        // Regular Missile Heading Control
        if (aimAngle < 0) {
            Turn = 1;
        }
        if (aimAngle > 0) {
            Turn = -1;
        }
        if (Math.abs(aimAngle) < Math.abs(missile.getAngularVelocity()) * damping) {
            missile.setAngularVelocity(aimAngle / damping);
        }

        // Regular Missile Course Correct
        float MFlightAng = VectorUtils.getAngle(new Vector2f(), missile.getVelocity());
        float MFlightCC = MathUtils.getShortestRotation(mFacing, MFlightAng);
        if (Math.abs(aimAngle) < 5) {
            if (MFlightCC < -20) {
                Strafe = 1;
            }
            if (MFlightCC > 20) {
                Strafe = -1;
            }
        }

        // Regular Missile ACCELERATE Control
//        if (Math.abs(aimAngle) < overshoot) Thrust = 1;{        
//            // Stop the missile if it getting too close
//            if (backOff) Thrust = -1;
//        }
        //Missile ACCELERATE Control with Evading Maneuver    
        if (Math.abs(aimAngle) < overshoot) {
            overshootTimer = 0f;
            overshootFlag = true;
        } else {
            overshootTimer += amount;
        }
        if (overshootTimer < overshootLag) {
            Thrust = 1;
        }
        if (backOff) {
            Thrust = -1;
        }

        // Omni Thrust Unit. for some carzy things.
        if (omniThrust) {
            // Omni Thrust acc limiter(TEST)
            omniThrustTimer += omniThrustAccLimit;
            if (omniThrustTimer >= 1f) {
                omniThrustTimer -= 1f;
                // relative velocity deviation vector calculations
                Vector2f absMVDev = Vector2f.sub((Vector2f) VectorUtils.getDirectionalVector(mLoc, lead).scale(flightSpeed), missile.getVelocity(), null);
                Vector2f relMVDev = VectorUtils.rotate(absMVDev, -mFacing, new Vector2f());
                // closing in maneuver(with max speed limit TEST)
                if (!backOff) {
                    if (relMVDev.x > 2.5f + omniThrustMaxSpeedLimit) {
                        Thrust = 1;
                    }
                    if (relMVDev.x < -(2.5f + omniThrustMaxSpeedLimit)) {
                        Thrust = -1;
                    }
                    if (relMVDev.y > 2.5f + omniThrustMaxSpeedLimit) {
                        Strafe = 1;
                    }
                    if (relMVDev.y < -(2.5f + omniThrustMaxSpeedLimit)) {
                        Strafe = -1;
                    }
                }
                // back off maneuver
                if (backOff) {
                    if (relMVDev.x > 2.5f) {
                        Thrust = -1;
                    }
                    if (relMVDev.x < -2.5f) {
                        Thrust = 1;
                    }
                    if (relMVDev.y < 2.5f) {
                        Strafe = -1;
                    }
                    if (relMVDev.y > -2.5f) {
                        Strafe = 1;
                    }
                }
            }
        }

        if (alwaysAcc) {
            Thrust = 1;
        }

        if (Thrust == 1) {
            missile.giveCommand(ShipCommand.ACCELERATE);
        }
        if (Thrust == -1) {
            missile.giveCommand(ShipCommand.ACCELERATE_BACKWARDS);
        }
        if (Turn == 1) {
            missile.giveCommand(ShipCommand.TURN_RIGHT);
        }
        if (Turn == -1) {
            missile.giveCommand(ShipCommand.TURN_LEFT);
        }
        if (Strafe == 1) {
            missile.giveCommand(ShipCommand.STRAFE_LEFT);
        }
        if (Strafe == -1) {
            missile.giveCommand(ShipCommand.STRAFE_RIGHT);
        }

        ////
        ////
        // Payload Release Decide
        // if the missile is close enough and facing to target. release payload
        float absFacingToLead = Math.abs(MathUtils.getShortestRotation(mFacing, VectorUtils.getAngle(mLoc, lead)));
        if (missile.getElapsed() > minTimeToSplit && dist < releaseRange && absFacingToLead < 3f) {
            firing = true;
        }
        ////
    }

    //////////////////////
    //    TARGETTING    //
    //////////////////////
    //will be called when firing
    public CombatEntityAPI assignCurrentTarget(MissileAPI missile) {
        ShipAPI source = missile.getSource();
        ShipAPI currentTarget = source.getShipTarget();

        // try "lock'n'fire" targeting behavior frist. 
        // get target form ship,
        if (currentTarget != null
                && currentTarget.isAlive()
                && currentTarget.getOwner() != missile.getOwner()) {
            //return the ship's target if it is valid
            return (CombatEntityAPI) currentTarget;
        } else {
            // If we don't got any valid target form ship, try "fire at target by clicking on them" behavior.
            // get nearest target form cursor
            List<ShipAPI> directTargets = CombatUtils.getShipsWithinRange(source.getMouseTarget(), 50f);
            if (!directTargets.isEmpty()) {
                Collections.sort(directTargets, new CollectionUtils.SortEntitiesByDistance(source.getMouseTarget()));
                for (ShipAPI tmp : directTargets) {
                    if (tmp.isAlive() && tmp.getOwner() != source.getOwner()) {
                        return (CombatEntityAPI) tmp;
                    }
                }
            }
            //still no target? OK, let's fake one for the remote control (FAF = false) missile.
            if (!FAF) {
                return new SimpleEntity(source.getMouseTarget());
            }
        }
        return null;
    }

    //will be called if current target is invalid
    public CombatEntityAPI reAssignTarget(MissileAPI missile) {
        ShipAPI newtarget = null;
        ShipAPI source = missile.getSource();
        int side = source.getOwner();
        float searchRange = missile.getMaxSpeed() * 2 * (missile.getMaxFlightTime() - missile.getElapsed());
        float distance, closestDistance = Float.MAX_VALUE;

        for (ShipAPI tmp : AIUtils.getNearbyEnemies(missile, searchRange)) {
            float mod = 0f;
            if (!CombatUtils.isVisibleToSide(tmp, side)) {
                continue;
            }
            if (tmp.isFighter()) {
                mod = searchRange;
            }
            if (tmp.isDrone() || tmp.getCollisionClass() == CollisionClass.NONE) {
                mod = 2 * searchRange;
            }
            distance = MathUtils.getDistance(tmp, missile.getLocation()) + mod;
            if (distance < closestDistance) {
                newtarget = tmp;
                closestDistance = distance;
            }
        }
        if (newtarget == null) {
            newtarget = AIUtils.getNearestEnemy(missile);
            if (newtarget != null && !CombatUtils.isVisibleToSide(newtarget, side)) {
                newtarget = null;
            }
        }
        return newtarget;
    }

    ////////////////////////
    // RELEASING PAYLOAD  //
    ////////////////////////
    public void releasingPayload(MissileAPI missile, float amount) {

        Vector2f mLoc = missile.getLocation();
        ShipAPI mSource = missile.getSource();
        firingTimer += amount;
        ////
        // charge up flashing FX
        if (firingTimer < firingDelay - 0.1f) {
            flashInterval.advance(amount);
            if (flashInterval.intervalElapsed()) {
                Vector2f randomPoint = MathUtils.getRandomPointOnCircumference(mLoc, 5f);
                CombatEntityAPI anchor1 = new AnchoredEntity(missile, randomPoint);
                //            CombatEntityAPI anchor2 = new SimpleEntity(randomPoint);
                engine.spawnEmpArc(mSource, mLoc, anchor1, anchor1, DamageType.ENERGY, 0f, 0f, 50f, null, 2f,
                        coler1, coler2);
                //            engine.spawnEmpArc(mSource, mLoc, anchor2, anchor2, DamageType.ENERGY, 0f, 0f, 50f, null, 2f,
                //                                           new Color(86,86,255,100), new Color(0,0,255,150) );
            }
        }
        ////
        ////
        //firing Payloads now        
        if (firingTimer > firingDelay) {
            Vector2f mVel = missile.getVelocity();
            float mFacing = missile.getFacing();
            //public CombatEntityAPI spawnProjectile(ShipAPI ship, WeaponAPI weapon, String weaponId, Vector2f point, float angle, Vector2f shipVelocity)
            for (int i = 0; i < payload1; i++) {
                float firingAng = MathUtils.clampAngle(mFacing + MathUtils.getRandomNumberInRange(-10f * accuracyCompensate, 10f * accuracyCompensate));
                CombatEntityAPI tmp = engine.spawnProjectile(
                        mSource,
                        missile.getWeapon(),
                        "neutrino_adv_torpedo_1",
                        mLoc,
                        firingAng,
                        mVel);
//                engine.spawnEmpArc(mSource, mLoc, null, new AnchoredEntity(tmp, tmp.getLocation()), DamageType.ENERGY, 0f, 0f, 50f, null, 10f,
//                        coler1, coler2);
//                engine.spawnEmpArc(mSource, mLoc, null, new AnchoredEntity(tmp, tmp.getLocation()), DamageType.ENERGY, 0f, 0f, 50f, null, 10f,
//                        coler1, coler2);
            }
            for (int i = 0; i < payload2; i++) {
                Vector2f random1 = MathUtils.getRandomPointOnCircumference(zero, 10);
                float firingAng = MathUtils.clampAngle(mFacing + MathUtils.getRandomNumberInRange(-12.5f * accuracyCompensate, 12.5f * accuracyCompensate));
                Vector2f random2 = MathUtils.getPointOnCircumference(zero, MathUtils.getRandomNumberInRange(-100, 100), mFacing);
                engine.spawnProjectile(
                        mSource,
                        missile.getWeapon(),
                        "neutrino_adv_torpedo_2",
                        Vector2f.add(mLoc, random1, null),
                        firingAng,
                        Vector2f.add(mVel, random2, null));
            }
            for (int i = 0; i < payload3; i++) {
                Vector2f random1 = MathUtils.getRandomPointOnCircumference(zero, 10);
                float firingAng = MathUtils.clampAngle(mFacing + MathUtils.getRandomNumberInRange(-15f * accuracyCompensate, 15f * accuracyCompensate));
                Vector2f random2 = MathUtils.getPointOnCircumference(zero, MathUtils.getRandomNumberInRange(-150, 150), mFacing);
                engine.spawnProjectile(
                        mSource,
                        missile.getWeapon(),
                        "neutrino_adv_torpedo_3",
                        Vector2f.add(mLoc, random1, null),
                        firingAng,
                        Vector2f.add(mVel, random2, null));
            }
            ////

            ////
            //VFX & SFX
            //void spawnExplosion(Vector2f loc, Vector2f vel, Color color, float size, float maxDuration);
            engine.spawnExplosion(mLoc, mVel, new Color(86, 86, 255, 100), 30, 2f);
            //public void addHitParticle(Vector2f loc, Vector2f vel, float size, float brightness, float duration, Color color)  
            //engine.addHitParticle(mLoc, mVel, 200, 1, 2, new Color(86,86,255,100));
            Global.getSoundPlayer().playSound("neutrino_photon_firing", 0.8f, 0.7f, mLoc, zero);
            ////

            ////
            //leave something and remove something :)
            engine.spawnProjectile(
                    mSource,
                    missile.getWeapon(),
                    "neutrino_adv_torpedo_4",
                    mLoc,
                    mFacing,
                    mVel).setAngularVelocity(MathUtils.getRandomNumberInRange(-30, 30));
            engine.removeEntity(missile);
        }
    }

    @Override
    public CombatEntityAPI getTarget() {
        return target;
    }

    @Override
    public void setTarget(CombatEntityAPI target) {
        this.target = target;
    }
}
