// by Deathfly
// to my surprise this piece of shit actually work?!
package data.scripts.plugins;

import com.fs.starfarer.api.combat.BaseEveryFrameCombatPlugin;
import com.fs.starfarer.api.combat.BeamAPI;
import com.fs.starfarer.api.combat.CollisionClass;
import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.combat.DamageType;
import com.fs.starfarer.api.combat.DamagingProjectileAPI;
import com.fs.starfarer.api.input.InputEventAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import static data.scripts.util.Neutrino_CollisionUtilsEX.getShipCollisionPoint;
import java.util.ArrayList;

import java.util.List;
import org.lazywizard.lazylib.MathUtils;

import org.lwjgl.util.vector.Vector2f;

public class Neutrino_GuardianShield extends BaseEveryFrameCombatPlugin {

    private CombatEngineAPI engine;
    private static final String KEY = "Neutrino_LocalData";

    @Override
    public void advance(float amount, List<InputEventAPI> events) {
        if (engine == null) {
            return;
        }
        if (engine.isPaused()) {
            return;
        }
        final Neutrino_LocalData.LocalData localData = (Neutrino_LocalData.LocalData) engine.getCustomData().get(KEY);

        List<ShipAPI> ships = engine.getShips();
        List<ShipAPI> toCheck = new ArrayList<>();
        if (!ships.isEmpty()) {
            for (ShipAPI ship : ships) {
                if (ship.getHullSpec().getHullId().contains("neutrino_guardianshield")
                        || ship.getHullSpec().getHullId().contains("neutrino_aegis")) {
                    toCheck.add(ship);
                }
            }
        }

        if (!toCheck.isEmpty()) {
            for (ShipAPI shipToCheck : toCheck) {
                if (shipToCheck.isHulk()) {
                    shipToCheck.setCollisionClass(CollisionClass.FIGHTER);
                    shipToCheck.setCollisionRadius(50);
                }
                if (shipToCheck.getHullSpec().getHullId().contains("neutrino_guardianshield")) {
                    ShipAPI parentShip = shipToCheck.getDroneSource();
                    if (!shipToCheck.isHulk()) {
                        shipToCheck.getLocation().set(parentShip.getLocation());
                        shipToCheck.setFacing(parentShip.getFacing());
                    }
                    if (localData.guardianShieldFluxMap.containsKey(parentShip)) {
                        shipToCheck.getFluxTracker().setCurrFlux(localData.guardianShieldFluxMap.get(parentShip));
                        localData.guardianShieldFluxMap.remove(parentShip);
                    }
                    if (shipToCheck.isLanding()) {
                        localData.guardianShieldFluxMap.put(parentShip, shipToCheck.getFluxTracker().getCurrFlux());
                    }
                    if (shipToCheck.getFluxTracker().isOverloaded() && Math.random()< 0.1) {
                        engine.applyDamage(shipToCheck, shipToCheck.getLocation(), MathUtils.getRandomNumberInRange(0F, 100F), DamageType.ENERGY, 0f, true, true, shipToCheck);
                    }
                }
            }

            List<DamagingProjectileAPI> projectiles = engine.getProjectiles();
            if (!projectiles.isEmpty()) {
                for (DamagingProjectileAPI proj : projectiles) {
                    if (proj.didDamage()
                            && proj.getCollisionClass() != CollisionClass.NONE
                            && proj.getDamageTarget() instanceof ShipAPI
                            && toCheck.contains(proj.getDamageTarget()) 
                            ) {
                        engine.removeEntity(proj);
                    }
                }
            }

            List<BeamAPI> beams = engine.getBeams();
            if (!beams.isEmpty()) {
                for (BeamAPI beam : beams) {
                    if (beam.getBrightness() > 0) {
                        Vector2f closest = null;
                        float closestDist = Float.MAX_VALUE;
                        for (ShipAPI shipToCheck : toCheck) {
                            if (beam.getSource().getOwner() == shipToCheck.getOwner()) {
                                continue;
                            }
                            Vector2f tmp = getShipCollisionPoint(beam.getFrom(), beam.getTo(), shipToCheck);
                            if (closest == null) {
                                closest = tmp;
                            } else if (tmp != null && MathUtils.getDistance(tmp, beam.getFrom()) < closestDist) {
                                closest = tmp;
                                closestDist = MathUtils.getDistance(tmp, beam.getFrom());
                            }
                        }
                        if (closest != null) {
                            beam.getTo().set(closest);
                        }
                    }
                }
            }
        }
    }

    @Override
    public void init(CombatEngineAPI engine) {
        this.engine = engine;
    }
}
