//by Deathfly
package data.scripts.weapons;

import com.fs.starfarer.api.combat.BeamAPI;
import com.fs.starfarer.api.combat.BeamEffectPlugin;
import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.util.IntervalUtil;

import data.scripts.util.Neutrino_ParticlesEffectLib;

;

public class NeutBeamParticleEffect implements BeamEffectPlugin {

    public NeutBeamParticleEffect() {
    }
    private final IntervalUtil interval = new IntervalUtil(0.05f, 0.05f);

    @Override
    public void advance(float amount, CombatEngineAPI engine, BeamAPI beam) {
        if (engine.isPaused()) {
            return;
        }
        float brightness = beam.getBrightness();
        if (brightness >= 0.5f) {
            interval.advance(amount);
            if (interval.intervalElapsed()) {
                float width = beam.getWidth();
                Neutrino_ParticlesEffectLib.ParticleBeamPath(
                        beam,
                        1f, 2, false,
                        width / 5,
                        30f,
                        10, 50,
                        3, (int) (width / 5),
                        0.8f, 1f,
                        0.3f, 0.6f,
                        beam.getCoreColor());
                
            }
        }
    }
}

