package data.scripts.weapons;

import com.fs.starfarer.api.AnimationAPI;
import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.combat.EveryFrameWeaponEffectPlugin;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.WeaponAPI;

public class NeutRingEveryFrameEffect implements EveryFrameWeaponEffectPlugin {

    private final float idleFPS = 10f;
    private final float activeFPS = 16f;
    private final float deltaFPS = 2f;

    @Override
    public void advance(float amount, CombatEngineAPI engine, WeaponAPI weapon) {
        ShipAPI ship = weapon.getShip();
        AnimationAPI anime = weapon.getAnimation();
        float currentFPS = anime.getFrameRate();
        if (ship.isHulk() && currentFPS > 0) {
            float setFPS = currentFPS - deltaFPS * amount;
            if (setFPS < 0) {
                setFPS = 0;
            }
            anime.setFrameRate(setFPS);
        } else if (ship.getPhaseCloak().isOn() && currentFPS < activeFPS) {
            float setFPS = currentFPS + deltaFPS * amount;
            if (setFPS > activeFPS) {
                setFPS = activeFPS;
            }
            anime.setFrameRate(setFPS);
        } else if (!ship.getPhaseCloak().isOn() && currentFPS > idleFPS) {
            float setFPS = currentFPS - deltaFPS * amount;
            if (setFPS < idleFPS) {
                setFPS = idleFPS;
            }
            anime.setFrameRate(setFPS);
        }
    }
}
