// by Deathfly
// WIP!
package data.scripts.weapons;

import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.combat.EveryFrameWeaponEffectPlugin;
import com.fs.starfarer.api.combat.WeaponAPI;
import org.lazywizard.lazylib.MathUtils;
import com.fs.starfarer.api.util.IntervalUtil;
import com.fs.starfarer.api.util.Misc;
import org.lwjgl.util.vector.Vector2f;

public class NeutSilverLanceEveryFrameWeaponEffect implements EveryFrameWeaponEffectPlugin {

    private float aim = 0;
    private final IntervalUtil interval = new IntervalUtil(0.1f, 0.15f);
    private final float offset = 0.2f;

    @Override
    public void advance(float amount, CombatEngineAPI engine, WeaponAPI weapon) {
        interval.advance(amount);
        if (interval.intervalElapsed()) {
            if (weapon.isFiring()) {
                float diff = MathUtils.getShortestRotation(aim, weapon.getCurrAngle());
                if (Math.abs(diff) > weapon.getTurnRate() * interval.getIntervalDuration()) {
                    diff = Math.copySign(weapon.getTurnRate() * interval.getIntervalDuration(), diff);
                }
                float RNG = MathUtils.getRandomNumberInRange(-offset, offset) * weapon.getChargeLevel();
                float aimTo = MathUtils.clampAngle(aim + RNG + diff);
                weapon.setCurrAngle(aimTo);
                float outOfArc = weapon.distanceFromArc(Vector2f.add(weapon.getLocation(), Misc.getUnitVectorAtDegreeAngle(aimTo), null));
                if (outOfArc != 0) {
                    float newAngV = Math.abs(weapon.getShip().getAngularVelocity()) > weapon.getTurnRate()
                            ? Math.copySign(weapon.getShip().getAngularVelocity(), outOfArc)
                            : Math.copySign(weapon.getTurnRate(), outOfArc);
                    weapon.getShip().setAngularVelocity(newAngV);
                }
            }
            aim = weapon.getCurrAngle();
        }
    }
}
