package data.scripts.world.systems;

import java.awt.Color;
import java.util.List;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.campaign.CargoAPI;
import com.fs.starfarer.api.campaign.LocationAPI;
import com.fs.starfarer.api.campaign.PlanetAPI;
import com.fs.starfarer.api.campaign.SectorAPI;
import com.fs.starfarer.api.campaign.SectorEntityToken;
import com.fs.starfarer.api.campaign.StarSystemAPI;
import com.fs.starfarer.api.campaign.econ.MarketAPI;
import com.fs.starfarer.api.fleet.FleetMemberType;
import com.fs.starfarer.api.impl.campaign.ids.Conditions;
import com.fs.starfarer.api.impl.campaign.ids.Submarkets;
import com.fs.starfarer.api.impl.campaign.submarkets.StoragePlugin;

public class Exelion {

	public void generate(SectorAPI sector) {
		StarSystemAPI system = sector.createStarSystem("");
                system.getLocation().set(-15500, -6500);
                LocationAPI hyper = Global.getSector().getHyperspace();
		
		system.setBackgroundTextureFilename("graphics/neut/backgrounds/Exelion2.jpg");
		
		// create the star and generate the hyperspace anchor for this system
		PlanetAPI star = system.initStar("blackhole","neut_star_blackhole",36f);   // location in hyperspace
		
		system.setLightColor(new Color(75, 75, 75)); // light color in entire system, affects all entities
		

		/*
		 * addPlanet() parameters:
		 * 1. What the planet orbits (orbit is always circular)
		 * 2. Name
		 * 3. Planet type id in planets.json
		 * 4. Starting angle in orbit, i.e. 0 = to the right of the star
		 * 5. Planet radius, pixels at default zoom
		 * 6. Orbit radius, pixels at default zoom
		 * 7. Days it takes to complete an orbit. 1 day = 10 seconds.
		 
		                                 1.          2.       3.            4.   5.   6.    7.        */
		//PlanetAPI p1 = system.addPlanet(star, "IS7", "neut_rocky_unstable", 10, 150, 4700, 100);
		//PlanetAPI a2 = system.addPlanet(star, "Salus", "gas_giant", 230, 350, 7000, 250);
		
		//PlanetAPI a21 = system.addPlanet(a2, "Cruor", "rocky_unstable", 45, 80, 800, 25);
		//PlanetAPI a22 = system.addPlanet(a2, "Volturn", "water", 110, 120, 1400, 45);
		
		//PlanetAPI a3 = system.addPlanet(star, "Umbra", "rocky_ice", 280, 150, 12000, 650);
		
		//p1.setCustomDescriptionId("neut_planet_IS7");
		//a2.setCustomDescriptionId("planet_salus");
		//a21.setCustomDescriptionId("planet_cruor");
		//a22.setCustomDescriptionId("planet_volturn");
		//a3.setCustomDescriptionId("planet_umbra");
		
		//p1.getSpec().setPlanetColor(new Color(255,215,190,255));
		//p1.getSpec().setAtmosphereColor(new Color(160,110,45,140));
		//p1.getSpec().setCloudColor(new Color(255,164,96,200));
		//p1.getSpec().setTilt(10);
		//p1.applySpecChanges();
		
		/*
		 * addAsteroidBelt() parameters:
		 * 1. What the belt orbits
		 * 2. Number of asteroids
		 * 3. Orbit radius
		 * 4. Belt width
		 * 6/7. Range of days to complete one orbit. Value picked randomly for each asteroid. 
		 */
		//system.addAsteroidBelt(p1, 50, 1100, 128, 40, 80);
		
		
		/*
		 * addRingBand() parameters:
		 * 1. What it orbits
		 * 2. Category under "graphics" in settings.json
		 * 3. Key in category
		 * 4. Width of band within the texture
		 * 5. Index of band
		 * 6. Color to apply to band
		 * 7. Width of band (in the game)
		 * 8. Orbit radius (of the middle of the band)
		 * 9. Orbital period, in days
		 
		The sun
							1. 		2.    	3.     	4.   5.		6.		7.		8.	  9.								*/
		system.addRingBand(star, "misc", "rings1", 256f, 0, Color.white, 256f, 400, 70f);
		system.addRingBand(star, "misc", "rings1", 256f, 2, Color.white, 256f, 475, -60f);
		system.addRingBand(star, "misc", "rings1", 256f, 1, Color.white, 256f, 550, 80f);
		system.addRingBand(star, "misc", "rings1", 256f, 2, Color.white, 256f, 475, -60f);
		system.addRingBand(star, "misc", "rings1", 256f, 3, Color.white, 256f, 375, 50f);		
//		system.addRingBand(star, "misc", "rings1", 256f, 2, Color.white, 256f, 225, 40f);		
//		system.addRingBand(star, "misc", "rings1", 256f, 0, Color.white, 256f, 175, -50f);
		
		system.addRingBand(star, "misc", "rings1", 256f, 2, Color.white, 256f, 700, 110f);
		
		system.addRingBand(star, "misc", "rings1", 256f, 3, Color.white, 256f, 875, -70f);
		system.addRingBand(star, "misc", "rings1", 256f, 2, Color.white, 256f, 950, 90f);
		system.addRingBand(star, "misc", "rings1", 256f, 3, Color.white, 256f, 1025, 110f);
//		system.addRingBand(star, "misc", "rings1", 256f, 1, Color.white, 256f, 950, -90f);
//		system.addRingBand(star, "misc", "rings1", 256f, 0, Color.white, 256f, 875, -70f);
		
		system.addRingBand(star, "misc", "rings1", 256f, 2, Color.white, 256f, 1200, -110f);
		
		system.addRingBand(star, "misc", "rings1", 256f, 1, Color.white, 256f, 1375, 90f);		 	
		system.addRingBand(star, "misc", "rings1", 256f, 0, Color.white, 256f, 1400, -50f);
		system.addRingBand(star, "misc", "rings1", 256f, 3, Color.white, 256f, 1450, 70f);
//		system.addRingBand(star, "misc", "rings1", 256f, 0, Color.white, 256f, 1500, 80f);
//		system.addRingBand(star, "misc", "rings1", 256f, 1, Color.white, 256f, 1550, -90f);		 

		system.addAsteroidBelt(star, 50, 500, 200, 10, -35);
		system.addAsteroidBelt(star, 50, 900, 200, 10, 55);
		system.addAsteroidBelt(star, 50, 1200, 200, 10, 45);	
		system.addAsteroidBelt(star, 50, 1500, 200, 10, -35);			

		// planet 1
		/*
		system.addRingBand(p1, "misc", "rings1", 256f, 2, Color.white, 256f, 250, 60f);		
		system.addRingBand(p1, "misc", "rings1", 256f, 1, Color.white, 256f, 325, 40f);
		system.addRingBand(p1, "misc", "rings1", 256f, 2, Color.white, 256f, 400, 60f);
		system.addRingBand(p1, "misc", "rings1", 256f, 2, Color.white, 256f, 475, 80f);

		system.addRingBand(p1, "misc", "rings1", 256f, 3, Color.white, 256f, 550, 70f);
		system.addRingBand(p1, "misc", "rings1", 256f, 3, Color.white, 256f, 650, 90f);
		system.addRingBand(p1, "misc", "rings1", 256f, 3, Color.white, 256f, 750, 1100f);
		system.addRingBand(p1, "misc", "rings1", 256f, 2, Color.white, 256f, 750, 110f);
	
		system.addAsteroidBelt(p1, 50, 400, 200, 10, -35);
		system.addAsteroidBelt(p1, 50, 800, 200, 10, 45);				
		*/
		
		/*
		JumpPointAPI jumpPoint = Global.getFactory().createJumpPoint("Jump Point Alpha");
		OrbitAPI orbit = Global.getFactory().createCircularOrbit(star, 0, 800, 40);
		jumpPoint.setOrbit(orbit);
		jumpPoint.setRelatedPlanet(star);
		jumpPoint.setStandardWormholeToHyperspaceVisual();
		system.addEntity(jumpPoint);
		*/
		
		
                //SectorEntityToken NCstation2 = system.addCustomEntity("neut_largeprocessing", "Abandoned Neutrino Facility", "neutrino_station_largeprocessing", "neutrinocorp");
                //NCstation2.setCircularOrbitPointingDown(star, 200, 1750, 90);
               // NCstation2.setCustomDescriptionId("neut_stationlargeprocessing");                  
                
                
                
                
 		SectorEntityToken NCstation2 = system.addOrbitalStation("neut_exelionabandoned", star, 200, 2050, 90, "Abandoned Neutrino Facility", "neutral");
		NCstation2.getMemory().set("$abandonedStation", true);
		MarketAPI market = Global.getFactory().createMarket("exelion_abandoned_station_market", NCstation2.getName(), 0);
		market.setPrimaryEntity(NCstation2);
		market.setFactionId(NCstation2.getFaction().getId());

		market.addCondition(Conditions.ABANDONED_STATION);

		market.addSubmarket(Submarkets.SUBMARKET_STORAGE);
		((StoragePlugin)market.getSubmarket(Submarkets.SUBMARKET_STORAGE).getPlugin()).setPlayerPaidToUnlock(true);
		NCstation2.setMarket(market);
		NCstation2.setCustomDescriptionId("neut_abandoned");
		NCstation2.setInteractionImage("illustrations", "abandoned_station");
	
 		NCstation2.getMarket().getSubmarket(Submarkets.SUBMARKET_STORAGE).getCargo().addSupplies(84);	      
		NCstation2.getMarket().getSubmarket(Submarkets.SUBMARKET_STORAGE).getCargo().addFuel(12);	               
                
		NCstation2.getMarket().getSubmarket(Submarkets.SUBMARKET_STORAGE).getCargo().addWeapons("neutrino_phasedarray", 1);            
		NCstation2.getMarket().getSubmarket(Submarkets.SUBMARKET_STORAGE).getCargo().addWeapons("neutrino_neutronpulse", 2);	      
		NCstation2.getMarket().getSubmarket(Submarkets.SUBMARKET_STORAGE).getCargo().addWeapons("neutrino_particlecannonarray", 1);	
                
		NCstation2.getMarket().getSubmarket(Submarkets.SUBMARKET_STORAGE).getCargo().addMothballedShip(FleetMemberType.SHIP, "neutrino_unsung_Hull", null);               
		NCstation2.getMarket().getSubmarket(Submarkets.SUBMARKET_STORAGE).getCargo().addMothballedShip(FleetMemberType.FIGHTER_WING, "neutrino_drohne_wing", null);                 
        
                
                
		//initStationCargo2(NCstation2);

		
		// example of using custom visuals below
//		a1.setCustomInteractionDialogImageVisual(new InteractionDialogImageVisual("illustrations", "hull_breach", 800, 800));
//		jumpPoint.setCustomInteractionDialogImageVisual(new InteractionDialogImageVisual("illustrations", "space_wreckage", 1200, 1200));
//		station.setCustomInteractionDialogImageVisual(new InteractionDialogImageVisual("illustrations", "cargo_loading", 1200, 1200));
		
		// generates hyperspace destinations for in-system jump points
		system.autogenerateHyperspaceJumpPoints(true, true);
			
	}

 	//Abandoned Neutrino Facility    
	/*private void initStationCargo2(SectorEntityToken NCstation2) {
		CargoAPI cargo = NCstation2.getCargo();
		addRandomWeapons(cargo, 1);
		
		
		cargo.addWeapons("neutrino_phasedarray", 1);			
		cargo.addWeapons("neutrino_neutronpulse", 2);		
		cargo.addWeapons("neutrino_particlecannonarray", 1);			

		
		cargo.addSupplies(84);
		cargo.addFuel(12);

	}
	*/	
	private void addRandomWeapons(CargoAPI cargo, int count) {
		List weaponIds = Global.getSector().getAllWeaponIds();
		for (int i = 0; i < count; i++) {
			String weaponId = (String) weaponIds.get((int) (weaponIds.size() * Math.random()));
			int quantity = (int)(Math.random() * 4f + 2f);
			cargo.addWeapons(weaponId, quantity);
		}
	}
	
}
