package data.shipsystems.scripts;

import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipwideAIFlags;
import com.fs.starfarer.api.plugins.ShipSystemStatsScript;
import java.awt.Color;

public class NeutrinoPhaseCloakStats implements ShipSystemStatsScript {

    @Override
    public void apply(MutableShipStatsAPI stats, String id, State state, float effectLevel) {
        ShipAPI ship = (ShipAPI) stats.getEntity();
        if (state != ShipSystemStatsScript.State.ACTIVE) {
            ship.getSpriteAPI().setAlphaMult(0.25f);
            if ((state == ShipSystemStatsScript.State.IN && effectLevel > 0.8f)
                    || state == ShipSystemStatsScript.State.OUT && effectLevel < 0.2f) {
                stats.getMaxSpeed().unmodify(id);
                stats.getTurnAcceleration().unmodify(id);
                stats.getAcceleration().unmodify(id);
                stats.getDeceleration().unmodify(id);
                stats.getMaxTurnRate().unmodify(id);
            } else {
                stats.getAcceleration().modifyPercent(id, 100f);
                stats.getDeceleration().modifyPercent(id, 100f);
                stats.getTurnAcceleration().modifyPercent(id, 100f);
                stats.getMaxTurnRate().modifyPercent(id, 100f);
                float speedMod = stats.getZeroFluxSpeedBoost().modified;
                stats.getMaxSpeed().modifyFlat(id, speedMod);
            }
            //VFX
            ship.setJitter(new Color(255, 175, 255, 200), (1 - effectLevel) / 2f, Math.round(3 * (1.25f - effectLevel)), 15 * (1.25f - effectLevel));
        }

//        try to do some AI trick here.
//        ShipwideAIFlags AIFlags = ship.getAIFlags();
//        float fluxPerUse = ship.getPhaseCloak().getFluxPerUse();
//        float hardFluxFree = ship.getFluxTracker().getMaxFlux() - ship.getFluxTracker().getHardFlux();
//        float fluxFree = ship.getFluxTracker().getMaxFlux() - ship.getFluxTracker().getCurrFlux();
//
//        if (AIFlags != null) {
//            if (hardFluxFree < fluxPerUse
//                    && ship.getPhaseCloak().isOn()
//                    &&(AIFlags.hasFlag(ShipwideAIFlags.AIFlags.BACK_OFF)|| AIFlags.hasFlag(ShipwideAIFlags.AIFlags.HAS_INCOMING_DAMAGE))) {
//                AIFlags.setFlag(ShipwideAIFlags.AIFlags.NEEDS_HELP);
//                AIFlags.setFlag(ShipwideAIFlags.AIFlags.KEEP_SHIELDS_ON);
//                AIFlags.setFlag(ShipwideAIFlags.AIFlags.DO_NOT_USE_FLUX);
//                AIFlags.setFlag(ShipwideAIFlags.AIFlags.DO_NOT_VENT);
//            }
//            if (hardFluxFree < fluxPerUse * 2f) {
//                AIFlags.setFlag(ShipwideAIFlags.AIFlags.BACK_OFF);
//                AIFlags.setFlag(ShipwideAIFlags.AIFlags.DO_NOT_VENT);
//                AIFlags.setFlag(ShipwideAIFlags.AIFlags.NEEDS_HELP);
//            }
//            if (fluxFree < fluxPerUse
//                    && hardFluxFree > fluxPerUse
//                    && (fluxPerUse - fluxFree) / ship.getMutableStats().getFluxDissipation().modified < ship.getFluxTracker().getTimeToVent() - 1f) {
//                AIFlags.setFlag(ShipwideAIFlags.AIFlags.DO_NOT_VENT);
//                AIFlags.setFlag(ShipwideAIFlags.AIFlags.KEEP_SHIELDS_ON);
//                AIFlags.setFlag(ShipwideAIFlags.AIFlags.BACK_OFF);
//            }
//        }
    }

    @Override
    public void unapply(MutableShipStatsAPI stats, String id) {
        stats.getMaxSpeed().unmodify(id);
        stats.getTurnAcceleration().unmodify(id);
        stats.getAcceleration().unmodify(id);
        stats.getDeceleration().unmodify(id);
        stats.getMaxTurnRate().unmodify(id);
    }

    @Override
    public StatusData getStatusData(int index, State state, float effectLevel) {
        return null;
    }
}
